(load "hw1.scm")

(define (test-it s t)
  (display s)
  (display " => ")
  (display t)
  (eval s))

(test-it '(multiple? 3 0) #f)
(test-it '(multiple? 3 1) #t)
(test-it '(multiple? 3 2) #f)
(test-it '(multiple? 3 3) #t)

(test-it '(area-of-triangle 1 0) 0)
(test-it '(area-of-triangle 1 1) 0.5)
(test-it '(area-of-triangle 1 2) 1.0)

(test-it '(dist-to-line -1 1 0 1 0) (/ (sqrt 2) 2))
(test-it '(dist-to-line -1 1 0 2 1) (/ (sqrt 2) 2))
(test-it '(dist-to-line -1 1 0 1 1) 0)
(test-it '(dist-to-line -1 1 -1 1 1) (/ (sqrt 2) 2))
(test-it '(dist-to-line -1 1 -1 1 2) 0)

(test-it '(sosbig 1 2 3) 13)
(test-it '(sosbig 3 2 1) 13)
(test-it '(sosbig 1 3 3) 18)
(test-it '(sosbig 1 1 3) 10)
(test-it '(sosbig 2 2 2) 8)

(test-it '(power-up 2 7) 3)
(test-it '(power-up 2 8) 4)
(test-it '(power-up 2 1000) 10)

(test-it '(pascal 0 0) 1)
(test-it '(pascal 1 1) 1)
(test-it '(pascal 2 0) 1)
(test-it '(pascal 2 1) 2)
(test-it '(pascal 2 2) 1)
(test-it '(pascal 4 2) 6)

(test-it '(clamp 0 1 3) 1)
(test-it '(clamp 0.5 1 3) 1)
(test-it '(clamp 1.5 1 3) 1.5)
(test-it '(clamp 2.0 1 3) 2.0)
(test-it '(clamp 3 1 3) 3)
(test-it '(clamp 4 1 3) 3)

(test-it '(root3 27) 3)
(test-it '(root3 64) 4)
(test-it '(root3 125) 5)

(test-it '(sum-powers-i 2 3) 15)
(test-it '(sum-powers-i 2 4) 31)
(test-it '(sum-powers-i 3 3) 40)
(test-it '(sum-powers-i 3 4) 121)
